<template>
   <div class="row card-binding">
        <div class="columns six">
            <label for="yandex-wallet">Номер кошелька</label>
             <input type="text"
                  name="для ввода номера яндекс кошелька"
                  id="yandex-wallet"
                  v-model="walletNumber"
                  placeholder=""
                  value=""
                  @input="validateBeforeSubmit"
                  data-vv-validate-on="blur"
                  v-validate="'required|min:11|max:16'"
                  v-mask="'################'"
                  @keyup.enter="$emit('enter')"
             />
            <validate-message
              v-show="vErrors.has('для ввода номера яндекс кошелька')">
              {{ vErrors.first('для ввода номера яндекс кошелька') }}
            </validate-message>
        </div>
        <error-block :errors="errorsForErrorBlock" @clear="errorsForErrorBlock = []"></error-block>
    </div>
</template>
<script>
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import ValidateMessage from '@/components/Validators/ValidateMessage'

export default {
    name: 'NewAccountYandex',
    data () {
      return {
        walletNumber: '',
        errorsForErrorBlock: []
      }
    },
    mixins: [
      ErrorHandleMixin
    ],
    components: {
      ValidateMessage
    },
    methods: {
      async validateBeforeSubmit () {
        // валидирует Яндекс.Кошелек перед отправкой
        try {
          const isAllOk = await this.$validator.validateAll()
          const accountData = {
            'type': 3,
            'description': this.walletNumber
          }
          if (isAllOk) {
            this.$emit('input', accountData)
          } else {
            this.$emit('input', null)
          }
          // const addedAccount = await backendApi.putData('accounts', account)
          // this.$store.commit(ACCOUNTS_ADD_ACCOUNT, addedAccount)
        } catch (error) {
          console.log(error, 'error catched')
          this.vErrors.clear()
          error.errors.forEach(error => {
            if (error.field === 'mainErrorBlock') {
              this.errorsForErrorBlock.push(error)
            } else {
              this.vErrors.add(error.field, error.message)
            }
          })
        }
      }
      // change (e) {
      //   if (this.validate(e.target.value)) {
      //     let accountData = {
      //       description: e.target.value
      //     }
      //     this.$emit('input', accountData)
      //   } else {
      //     this.$emit('input', null)
      //   }
      // },
      // validate (value) {
      //   return true
      // }
    }
  }
</script>
<style scoped>
  .login-page .card-binding .card-period {
    text-align: right;
    margin-bottom: 10px;
    color: #898989;
    font-size: 15px;
    font-weight: 400;
    padding-top: 50px;
}
  @media (max-width: 1099px) {
    .login-page .card-binding .card-period {
      text-align: left;
      padding-top: 0px;
    }

    .login-page .card-binding .adaptive-col {
      width: 48%;
    }

    .login-page .card-binding .first-col {
      margin-right: 4%;
    }
  }
</style>
